/********************************************
* Mac binary file infomation  ver2.02
*		Copyleft|free 1995-96 tyappe
** Main Source
********************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<signal.h>
#include	<ctype.h>
#include	<utime.h>
#include	<time.h>
#include	<errno.h>
#include	"mb.h"

/** prottype def **/
int	main() ;		/** main program **/
static	int	mbinfosub() ;	/** MacBinary heador infomation **/
static	int	mbmakesub() ;	/** MacBinary heador set **/
static	int	txtmksub() ;	/** TEXT->Mac convert **/
static	int	anl_arg() ;	/** command line anarize **/
static	int	sig_hand() ;	/** signal handlor(SIGINT) **/
static	void	hedcvt() ;	/** inside work->MacBinary heador convert **/

/** option default flags **/
static	struct	Options {
	int	nopt ;		/** Infomation **/
	int	topt ;		/** TITLE print flag **/
	int	wopt ;		/** writing information flag **/
	int	mopt ;		/** make MacBinaryII flag **/
	int	dopt ;		/** stdin text convort flag **/
	int	xopt ;		/** write file update flag **/
	char	*srcfilen ;	/** source file name **/
	char	*resfilen ;	/** resouce file name **/
	char	*outfilen ;	/** dist file name **/
	char	*suffix ;	/** suffix **/
} opt={
	1 ,		/** Infomation **/
	1 ,		/** TITLE print **/
	1 ,		/** writing information **/
	0 ,		/** no make MacBinaryII **/
	0 ,		/** no stdin TEXT convert **/
	1 ,		/** write file date update **/
	NULL ,		/** source file name **/
	NULL ,		/** resouce file name **/
	NULL ,		/** dist file name **/
	NULL		/** suffix **/
} ;

/** Main Program **/
int	main(argc, argv)
int	argc;				/** param count(in) **/
char	*argv[];			/** param(in) **/
{
	FILE	*fp, *rfp, *wfp, *sfp ;
	int	cmdn ;
	char	**ptr, *pt1 ;

	(void)signal(SIGINT, SIG_IGN) ;
	if (strlen(argv[0])<PATHMAXSIZE) {
		(void)strcpy(xpath, argv[0]) ;
		if ((pt1 = strrchr(xpath, PATHSEPA)) != NULL) {
			pt1[1]=(char)NULL ;
		}
	}
	cmdn=anl_arg(argc, argv, &opt) ;
	if (!opt.dopt && opt.srcfilen==NULL ||
	    (opt.mopt||opt.dopt) && opt.outfilen==NULL) {
		ptr=usagemes ;
		while (*ptr!=NULL)	(void)fprintf(stderr, "%s\n", *ptr++) ;
		(void)exit(1);
		/*NOTREACHED*/
	}
	if (opt.topt)	(void)fprintf(stderr, "%s\n", usagemes[0]) ;
	if (opt.outfilen!=NULL) {
		if ((fp = fopen(opt.outfilen, "r"))!=NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F2ERR, opt.outfilen) ;
			(void)fclose(fp) ;
			(void)exit(1);
			/*NOTREACHED*/
		}
	}
	(void)signal(SIGINT, (void*)sig_hand) ;
	if (opt.mopt) {
		if ((rfp = fopen(opt.srcfilen, "rb"))==NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt.srcfilen);
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		sfp=NULL ;
		if (opt.resfilen!=NULL) {
			if ((sfp = fopen(opt.resfilen, "rb"))==NULL) {
				(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt.resfilen);
				(void)fclose(rfp);
				(void)exit(1) ;
				/*NOTREACHED*/
			}
			if (reschk(sfp)) {
				(void)fprintf(stderr, "%s<%s>\n", FRERR, opt.resfilen);
				(void)fclose(rfp);
				(void)fclose(sfp);
				(void)exit(1) ;
				/*NOTREACHED*/
			}
		}
		if ((wfp = fopen(opt.outfilen, "wb"))==NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt.outfilen);
			(void)fclose(rfp);
			if (sfp != NULL)	(void)fclose(sfp) ;
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		if (mbmakesub(rfp, wfp, sfp, &opt)) {
			(void)fclose(rfp);
			(void)fclose(wfp);
			if (sfp != NULL)	(void)fclose(sfp) ;
			(void)remove(opt.outfilen) ;
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		(void)fclose(rfp);
		(void)fclose(wfp);
		if (sfp != NULL)	(void)fclose(sfp) ;
	}
	else if(opt.dopt) {
		if ((wfp = fopen(opt.outfilen, "wb"))==NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt.outfilen);
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		if (txtmksub(wfp, &opt)) {
			(void)fclose(wfp);
			(void)remove(opt.outfilen) ;
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		(void)fclose(wfp);
	}
	else {
		if ((rfp = fopen(opt.srcfilen, "rb")) == NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt.srcfilen);
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		if (mbinfosub(rfp, &opt)) {
			(void)fclose(rfp);
			(void)exit(1) ;
			/*NOTREACHED*/
		}
		(void)fclose(rfp);
	}
	(void)exit(0) ;
	/*NOTREACHED*/
}

/** MacBinary heador print **/
static	int	mbinfosub(rfp, opt)
FILE	*rfp ;				/** read FP(in) **/
struct	Options *opt ;			/** option(in) **/
{
	FILE	*wfp ;
	struct	MacBinary2	mb ;
	struct	utimbuf	utimwk ;
	struct	tm	*tim ;
	time_t	fuptim ;

	if (opt->resfilen!=NULL) {
		if ((wfp = fopen(opt->resfilen, "r"))!=NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F2ERR, opt->resfilen);
			(void)fclose(wfp) ;
			return 1 ;
		}
	}
	(void)memset((void*)&mb, 0, sizeof mb) ;
	if (mbchk(0x02|opt->nopt, rfp, &mb)) {
		return 1 ;
	}
	(void)setbuf(stdout, NULL) ;
	if (opt->outfilen!=NULL) {
		if (dskchk(mb.fdfsize, opt->outfilen)) {
			(void)fprintf(stderr, "%s<%s>\n", DSKFUL, opt->outfilen);
			return 1 ;
		}
		if ((wfp = fopen(opt->outfilen, "wb"))==NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt->outfilen);
			return 1 ;
		}
		if (opt->wopt) {
			(void)printf("  Now Datafork writing to <%s>", opt->outfilen) ;
		}
		if (forkwrite(opt->wopt, rfp, wfp, mb.fdfsize)) {
			(void)fclose(wfp) ;
			(void)remove(opt->outfilen) ;
		}
		else	(void)fclose(wfp) ;
		if (opt->xopt) {
			fuptim=(mb.fupdate<MTIME)? 0: mb.fupdate-MTIME ;
			tim=gmtime(&fuptim) ;
			fuptim=mktime(tim) ;
			if (fuptim==(-1) && errno==ERANGE) {
				(void)fprintf(stderr, "%s\n", UTERR);
			}
			else {
				utimwk.actime=fuptim ;
				utimwk.modtime=fuptim ;
				if (utime(opt->outfilen, &utimwk)<0) {
					(void)fprintf(stderr, "%s\n", UTERR);
				}
			}
		}
	}
	if (opt->resfilen!=NULL && mb.frfsize>0) {
		opt->outfilen=opt->resfilen ;
		if (dskchk(mb.frfsize, opt->outfilen)) {
			(void)fprintf(stderr, "%s<%s>\n", DSKFUL, opt->outfilen);
			return 1 ;
		}
		if ((wfp = fopen(opt->outfilen, "wb"))==NULL) {
			(void)fprintf(stderr, "%s<%s>\n", F1ERR, opt->outfilen);
			return 1 ;
		}
		if (opt->wopt) {
			(void)printf("  Now Resoucefork writing to <%s>",
			    opt->outfilen) ;
		}
		if (forkwrite(opt->wopt, rfp, wfp, mb.frfsize)) {
			(void)fclose(wfp) ;
			(void)remove(opt->outfilen) ;
		}
		else	(void)fclose(wfp) ;
		if (opt->xopt) {
			fuptim=(mb.fupdate<MTIME)? 0: mb.fupdate-MTIME ;
			tim=gmtime(&fuptim) ;
			fuptim=mktime(tim) ;
			if (fuptim==(-1) && errno==ERANGE) {
				(void)fprintf(stderr, "%s\n", UTERR);
			}
			else {
				utimwk.actime=fuptim ;
				utimwk.modtime=fuptim ;
				if (utime(opt->outfilen, &utimwk)<0) {
					(void)fprintf(stderr, "%s\n", UTERR);
				}
			}
		}
	}
	return 0 ;
}

/** MacBinary heador **/
static	int	mbmakesub(rfp, wfp, sfp, opt)
FILE	*rfp ;				/** data fork read FP(in) **/
FILE	*wfp ;				/** write FP(in) **/
FILE	*sfp ;				/** resouce fork read FP(in) **/
struct	Options *opt ;			/** option(in) **/
{
	struct	MacBinary2	mb ;
	unsigned char   wd[HEDSIZE] ;
	size_t	rn ;

	(void)memset((void*)&mb, 0, sizeof mb) ;
	if (mbchk(0x00, rfp, &mb)==0) {
		(void)fprintf(stderr, "%s<%s>\n", F4ERR, opt->srcfilen);
		return 1 ;
	}
	(void)memset((void*)&mb, 0, sizeof mb) ;
	if (mbhedset(opt->srcfilen, opt->resfilen, opt->suffix, &mb)) {
		return 1 ;
	}
	if (dskchk(HEDSIZE+(mb.fdfsize+ALINE-1)/ALINE*ALINE+
	    (mb.frfsize+ALINE-1)/ALINE*ALINE, opt->outfilen)) {
		(void)fprintf(stderr, "%s<%s>\n", DSKFUL, opt->outfilen);
		return 1 ;
	}
	hedcvt(wd, &mb) ;
	rn=fwrite((void*)wd, (size_t)sizeof wd[0], HEDSIZE, wfp) ;
	if (rn!=HEDSIZE) {
		(void)fprintf(stderr, "%s\n", WRERR) ;
		return 1 ;
	}
	rewind(rfp) ;
	(void)setbuf(stdout, NULL) ;
	if (opt->wopt) {
		(void)printf("  Now Datafork writing from <%s>", opt->srcfilen) ;
	}
	if (forkwrite(opt->wopt, rfp, wfp, mb.fdfsize)) {
		return 1 ;
	}
	if (alnwrite(wfp, (ALINE-(mb.fdfsize%ALINE))%ALINE)) {
		return 1 ;
	}
	if (sfp!=NULL && mb.frfsize>0) {
		if (opt->wopt) {
			(void)printf(" Now Resoucefork writing from <%s>",
			    opt->resfilen) ;
		}
		if (forkwrite(opt->wopt, sfp, wfp, mb.frfsize)) {
			return 1 ;
		}
		if (alnwrite(wfp, (ALINE-(mb.frfsize%ALINE))%ALINE)) {
			return 1 ;
		}
	}
	return 0 ;
}

/** TEXTMac TEXT convert **/
static	int	txtmksub(wfp, opt)
FILE	*wfp ;				/** write FP(in) **/
struct	Options *opt ;			/** option(in) **/
{
	struct	MacBinary2	mb ;
	unsigned char   wd[HEDSIZE] ;
	size_t	rn ;
	char	wk, cr ;

	(void)memset((void*)&mb, 0, sizeof mb) ;
	if (mbhedset(opt->outfilen, NULL, opt->suffix, &mb)) {
		return 1 ;
	}
	hedcvt(wd, &mb) ;
	rn=fwrite((void*)wd, (size_t)sizeof wd[0], HEDSIZE, wfp) ;
	if (rn!=HEDSIZE) {
		(void)fprintf(stderr, "%s\n", WRERR) ;
		return 1 ;
	}

	cr=(char)NULL ;
	while ((wk=getchar())!=EOF) {
		if (wk==0x03)	break ;
		if (wk==0x1A)	break ;
		if (wk==LF) {
			cr=LF ;
			(void)putc(OUTCR, wfp) ;
		} else if(wk==CR) {
			if (cr!=LF)	(void)putc(OUTCR, wfp) ;
			cr=(char)NULL ;
		} else {
			(void)putc(wk, wfp) ;
			cr=(char)NULL ;
		}
	}
	(void)fflush(wfp) ;
	if (mbhedset(opt->outfilen, NULL, opt->suffix, &mb)) {
		return 1 ;
	}
#ifdef	DEBUG
	(void)printf("fdfsize=%d\n", mb.fdfsize) ;
#endif
	mb.fdfsize = ftell(wfp)-HEDSIZE ;
	hedcvt(wd, &mb) ;
	if (alnwrite(wfp, (ALINE-(mb.fdfsize%ALINE))%ALINE)) {
		return 1 ;
	}
	(void)fflush(wfp) ;
#ifdef	DEBUG
	(void)printf("ftell=%d\n", ftell(wfp)) ;
#endif
	(void)rewind(wfp) ;
	rn=fwrite((void*)wd, (size_t)sizeof wd[0], HEDSIZE, wfp) ;
	if (rn!=HEDSIZE) {
		(void)fprintf(stderr, "%s\n", WRERR) ;
		return 1 ;
	}
	return 0 ;
}

static	void	hedcvt(wd, mb)
char	*wd ;			/** write MacBinaryII heador(out) **/
struct	MacBinary2	*mb ;	/** MacBinaryII work(update) **/
{
	(void)memset((void*)wd, 0, (size_t)HEDSIZE) ;
	wd[1]=mb->fnsize&0x1F ;
	(void)strncpy(&wd[2], mb->fname, FNMAX) ;
	(void)memcpy(&wd[65], mb->ftype, 4) ;
	(void)memcpy(&wd[69], mb->fcreator, 4) ;

/*	(void)memcpy(&wd[83], (void*)&mb->fdfsize, sizeof mb->fdfsize); */
/*	(void)memcpy(&wd[87], (void*)&mb->frfsize, sizeof mb->frfsize); */
/*	(void)memcpy(&wd[91], (void*)&mb->fmkdate, sizeof mb->fmkdate); */
/*	(void)memcpy(&wd[95], (void*)&mb->fupdate, sizeof mb->fupdate); */
	wd[83]=mb->fdfsize>>24&0xFF ;
	wd[84]=mb->fdfsize>>16&0xFF ;
	wd[85]=mb->fdfsize>>8&0xFF ;
	wd[86]=mb->fdfsize&0xFF ;

	wd[87]=mb->frfsize>>24&0xFF ;
	wd[88]=mb->frfsize>>16&0xFF ;
	wd[89]=mb->frfsize>>8&0xFF ;
	wd[90]=mb->frfsize&0xFF ;

	wd[91]=mb->fmkdate>>24&0xFF ;
	wd[92]=mb->fmkdate>>16&0xFF ;
	wd[93]=mb->fmkdate>>8&0xFF ;
	wd[94]=mb->fmkdate&0xFF ;

	wd[95]=mb->fupdate>>24&0xFF ;
	wd[96]=mb->fupdate>>16&0xFF ;
	wd[97]=mb->fupdate>>8&0xFF ;
	wd[98]=mb->fupdate&0xFF ;

	wd[73]=(mb->fflg>>8)&0xFF ;
	wd[101]=mb->fflg&0xFF ;
	wd[122]=mb->fver1 ;
	wd[123]=mb->fver1 ;
	mb->fcrc=calcrc(wd,124) ;
/*	(void)memcpy(&wd[124], (void*)&mb->fcrc, sizeof mb->fcrc); */
	wd[124]=mb->fcrc>>8&0xFF ;
	wd[125]=mb->fcrc&0xFF ;

	return ;
}

/** command line analyze **/
static	int	anl_arg(argc, argv, opt)
int	argc;				/** param count(in) **/
char	*argv[];			/** paramtor(in) **/
struct	Options	*opt ;			/** option(update) **/
{
	char	*ptr;
	int	i, cmdn;

	cmdn=0 ;
	i=1 ;
	ptr=argv[i] ;
	while (i<argc && ptr!=NULL) {
		if (ptr[0] == '-') {
			switch (ptr[1]) {
			case 'i' :
				opt->mopt=0 ;
				opt->nopt=1 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 'x' :
				opt->xopt=0 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 'm' :
				opt->mopt=1 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 'n' :
				opt->nopt=0 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 't' :
				opt->topt=0 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 'w' :
				opt->wopt=0 ;
				if (ptr[2] != (char)NULL) {
					ptr[1]='-' ;
					ptr++ ;
				}
				else	ptr=argv[++i] ;
				break ;
			case 's' :
				ptr= &ptr[2] ;
				while (isspace(*ptr))	++ptr ;
				if (*ptr == (char)NULL) {
					opt->suffix=argv[++i] ;
				}
				else	opt->suffix=ptr ;
				ptr=argv[++i] ;
				break ;
			case 'd' :
				opt->dopt=1 ;
				ptr= &ptr[2] ;
				while (isspace(*ptr))	++ptr ;
				if (*ptr == (char)NULL) {
					opt->outfilen=argv[++i] ;
				}
				else	opt->outfilen=ptr ;
				ptr=argv[++i] ;
				break ;
			case 'o' :
				ptr= &ptr[2] ;
				while (isspace(*ptr))	++ptr ;
				if (*ptr == (char)NULL) {
					opt->outfilen=argv[++i] ;
				}
				else	opt->outfilen=ptr ;
				ptr=argv[++i] ;
				break ;
			case 'r' :
				ptr= &ptr[2] ;
				while (isspace(*ptr))	++ptr ;
				if (*ptr == (char)NULL) {
					opt->resfilen=argv[++i] ;
				}
				else	opt->resfilen=ptr ;
				ptr=argv[++i] ;
				break ;
			default :
				return (-1) ;
			}
		}
		else {
			switch (cmdn) {
			case 0:
				if(opt->dopt)
					opt->outfilen=argv[i] ;
				else
					opt->srcfilen=argv[i] ;
				cmdn++ ;
				break ;
			case 1:
				if(opt->dopt)	return (-1) ;
				opt->outfilen=argv[i] ;
				cmdn++ ;
				break ;
			default :
				return (-1) ;
			}
			ptr=argv[++i] ;
		}
	}
	return cmdn;
}

/** signal handler **/
static	int	sig_hand(sig)
int	sig ;
{
	(void)fprintf(stdout, "forced quit\n") ;
	if (opt.outfilen) {
		(void)remove(opt.outfilen) ;
		(void)fprintf(stdout, "  Remove file..<%s>\n", opt.outfilen) ;
	}
	(void)exit(1);
}
