/********************************************
* Mac binary file infomation  ver2.01
*		Copyleft|free 1995-96 tyappe
** Hedder File
********************************************/

#define	WORKSIZ	65536		/** write buffer size  **/
#define	ALINE	128		/** MacBinary data,resouce alain **/
#define	HEDSIZE	128		/** MacBinary hedor size **/
#define	NOWVER	129		/** MacBinaryII latest version **/
#define	FNMAX	31		/** Mac max file length **/
#define	MTIME	((1970-1904)*365+17)*24*60*60	/** base date -Mac base **/
#define	MBRCNAME	".mbrc"	/** suffix definition file name **/
#define	PATHMAXSIZE	256	/** path max length **/
#define	BFSIZE	256		/** suffix definition file read buffer **/
#define	MFINDFLG	0x0100	/** default finder flag **/
#define	UNDEFTYPE	"????"	/** undefine type **/
#define	UNDEFCREATOR	"????"	/** undefine creator **/
#define	CR	0x0D
#define	LF	0x0A
#define	OUTCR	0x0D		/** new line code **/

#ifdef	X68000
#define	PATHSEPA	'\\'	/** path separator(Human68k) **/
#else
#define	PATHSEPA	'/'	/** path separator(UNIX system) **/
#endif

/** Prottype Define **/
extern	int	mbchk() ;		/** MacBinary judge&print **/
extern	int	dskchk() ;		/** disk chack **/
extern	unsigned short	calcrc() ;	/** calculate CRC **/
extern	int	sufchk() ;		/** suffix def file search **/
extern	int	forkwrite() ;		/** fork writing **/
extern	int	alnwrite() ;		/** alain writing **/
extern	int	mbhedset() ;		/** MacBinary2 hedor set **/
extern	int	reschk() ;		/** resouce check **/
extern	char	*fnfiles() ;		/** filename get **/

extern	char	*usagemes[] ;		/** usage put **/
extern	char	*week[] ;		/** week **/
extern	char	*find[] ;		/** finder flags **/
extern	char	mbrcrev[] ;		/** suffix def file  **/
extern	char	xpath[PATHMAXSIZE] ;	/** exec path **/

/** Message Define **/
#define	PSNAME	" mb"
#define	F1ERR	" mb: Can't file open error ... "
#define	F2ERR	" mb: alrady file existence ... "
#define	F3ERR	" mb: def file invalid ... "
#define	F4ERR	" mb: alrady MacBinary ... "
#define	FRERR	" mb: no resouce fork recognition ... "
#define	SKERR	" mb: file Seek error."
#define	RDERR	" mb: read error."
#define	WRERR	" mb: write error."
#define	DFERR	" mb: free Disk capacity calculate error."
#define	DSKFUL	" mb: Disk full. "
#define	MB1ERR	" mb: no MacBinary."
#define	MB2ERR	" mb: no MacBinaryII."
#define	MB1MSG	" mb: MacBinaryI."
#define	MB2MSG	" mb: MacBinaryII."
#define	MB3MSG	" mb: MacBinaryII(unknown version)."
#define	UTERR	" mb: date update failed"
#define	DTERR	"1970/01/01 00:00:00 before"

/** MacBinary2 Heder Work struct def. **/
struct	MacBinary2 {
	long	fnsize ;	/* file name length */
	char	fname[64] ;	/* file name */
	char	ftype[8] ;	/* file type */
	char	fcreator[8] ;	/* creator */
	unsigned long	fdfsize ;	/* data fork length */
	unsigned long	frfsize ;	/* resouce fork length */
	unsigned long	fmkdate ;	/* create date */
	unsigned long	fupdate ;	/* update date */
	unsigned short	fflg ;	/* finder flag */
	short	filler1 ;
	long	fver1 ;		/* macbinary header version */
	long	fver2 ;		/* macbinary header version */
	unsigned short	fcrc ;	/* CRC */
	short	filler2 ;
} ;

