/********************************************
* Mac binary file infomation  ver2.02
*		Copyleft|free 1995-96 tyappe
** fork write
********************************************/

#include	<stdio.h>
#include	<memory.h>
#include	"mb.h"

/** data fork writing buff **/
static	char	rwork[WORKSIZ] ;

/** alaign writeing  **/
extern	int	alnwrite(wfp, size)
FILE	*wfp ;				/** write fp(in) **/
long	size ;				/** write size(in) **/
{
	char	zerowork[ALINE] ;
	long	rn ;
	size_t	rsiz ;

#ifdef	DEBUG
	(void)printf("alaign write %d\n",size) ;
#endif
	(void)memset((void*)zerowork, 0, (size_t)sizeof zerowork) ;
	rsiz=(size>ALINE)? ALINE: size ;
	rn=fwrite((void*)zerowork, (size_t)sizeof zerowork[0], rsiz, wfp) ;
	if (rn!=rsiz) {
		(void)fprintf(stderr, "%s\n", WRERR) ;
		return (-1) ;
	}
	return 0 ;
}

/** fork writing **/
extern	int	forkwrite(wopt, rfp, wfp, size)
int	wopt ;				/** message out mode(in) **/
FILE	*rfp ;				/** read fp(in) **/
FILE	*wfp ;				/** write fp(in) **/
unsigned long	size ;			/** write size(in) **/
{
	size_t	rn, rsiz ;

	while (size>0) {
		rsiz=(size>WORKSIZ)? WORKSIZ: size ;
		rn=fread((void*)rwork, (size_t)sizeof rwork[0], rsiz, rfp) ;
		if (rn!=rsiz) {
			if (wopt)	(void)putchar('\n') ;
			(void)fprintf(stderr, "%s\n", RDERR) ;
			return (-1) ;
		}
		rn=fwrite((void*)rwork, (size_t)sizeof rwork[0], rsiz, wfp) ;
		if (rn!=rsiz) {
			if (wopt)	(void)putchar('\n') ;
			(void)fprintf(stderr, "%s\n", WRERR) ;
			return (-1) ;
		}
		if (wopt) {
			(void)putchar('.') ;
		}
		size -= rsiz ;
	}
	if (wopt)	(void)putchar('\n') ;
	return 0 ;
}

